angular.module('focaModalProveedor')
    .controller('focaModalProveedorCtrl', [
        '$timeout',
        '$filter',
        '$scope',
        '$uibModalInstance',
        'focaModalProveedorService',
        'transportista',
        function ($timeout, $filter, $scope, $uibModalInstance,
            focaModalProveedorService, transportista) {

            $scope.filters = '';
            $scope.primerBusqueda = false;
            // pagination
            $scope.numPerPage = 10;
            $scope.currentPage = 1;
            $scope.filteredProveedores = [];
            $scope.currentPageProveedores = [];
            $scope.selectedProveedores = -1;
            $scope.transportista = transportista | false;

            $scope.busquedaPress = function(key) {
                if (key === 13) {
                    $scope.searchLoading = true;
                    var json = {
                        razonCuitCod: $scope.filters
                    };
                    var funcion = transportista ? 'getTransportistas' : 'getProveedores';
                    focaModalProveedorService[funcion](json).then(
                        function(res) {
                            for (var i = res.data.length - 1; i >= 0; i--) {
                                if (res.data[i].COD === 0) {
                                    delete res.data[i];
                                }
                            }
                            $scope.primerBusqueda = true;
                            $scope.proveedores = res.data;
                            $scope.search(true);
                            primera();
                            $scope.searchLoading = false;
                        });
                }
            };
            $scope.busquedaPress(13);
            $scope.search = function (pressed) {
                if($scope.primerBusqueda) {
                    $scope.filteredProveedores = $filter('filter')(
                        $scope.proveedores, {$: $scope.filters}
                    );

                    if(pressed && $scope.filteredProveedores.length === 0){
                        $timeout(function() {
                            angular.element('#search')[0].focus();
                            $scope.filters = '';
                        });
                    }

                    $scope.lastPage = Math.ceil(
                        $scope.filteredProveedores.length / $scope.numPerPage
                    );

                    $scope.resetPage();
                }
            };

            $scope.resetPage = function () {
                $scope.currentPage = 1;
                $scope.selectPage(1);
            };

            $scope.selectPage = function (page) {
                console.info(page);
                var start = (page - 1) * $scope.numPerPage;
                var end = start + $scope.numPerPage;
                $scope.paginas = [];
                $scope.paginas = calcularPages(page);
                $scope.currentPageProveedores = $scope.filteredProveedores.slice(start, end);
                $scope.currentPage = page;
            };

            $scope.select = function(proveedor) {
                $uibModalInstance.close(proveedor);
            };

            $scope.cancel = function() {
                $uibModalInstance.dismiss('cancel');
            };

            $scope.busquedaDown = function(key) {
                if (key === 40) {
                    primera(key);
                }
            };

            $scope.itemProveedor = function(key) {
                if (key === 38) {
                    anterior(key);
                }

                if (key === 40) {
                    siguiente(key);
                }

                if (key === 37) {
                    retrocederPagina();
                }

                if (key === 39) {
                    avanzarPagina();
                }
            };

            function calcularPages(paginaActual) {
                var paginas = [];
                paginas.push(paginaActual);

                if (paginaActual - 1 > 1) {
                    
                    paginas.unshift(paginaActual - 1);
                    if (paginaActual - 2 > 1) {
                        paginas.unshift(paginaActual - 2);
                    }
                }

                if (paginaActual + 1 < $scope.lastPage) {
                    paginas.push(paginaActual + 1);
                    if (paginaActual + 2 < $scope.lastPage) {
                        paginas.push(paginaActual + 2);
                    }
                }

                if (paginaActual !== 1) {
                    paginas.unshift(1);
                }

                if (paginaActual !== $scope.lastPage) {
                    paginas.push($scope.lastPage);
                }

                return paginas;
            }

            function primera() {
                $scope.selectedProveedores = 0;
            }

            function anterior() {
                if ($scope.selectedProveedores === 0 && $scope.currentPage > 1) {
                    retrocederPagina();
                } else {
                    $scope.selectedProveedores--;
                }
            }

            function siguiente() {
                if ($scope.selectedProveedores < $scope.currentPageProveedores.length - 1 ) {
                    $scope.selectedProveedores++;
                } else {
                        avanzarPagina();
                }
            }

            function retrocederPagina() {
                if ($scope.currentPage > 1) {
                    $scope.selectPage($scope.currentPage - 1);
                    $scope.selectedProveedores = $scope.numPerPage - 1;
                }
            }

            function avanzarPagina() {
                if ($scope.currentPage < $scope.lastPage) {
                    $scope.selectPage($scope.currentPage + 1);
                    $scope.selectedProveedores = 0;
                }
            }
        }]
    );
